import os
import subprocess
import re

OBJ_FILE="../../../out/ida_lwip_example_psur5_core0.elf"

functions=dict()
functionGroups=dict()

mapping = {
    "api_lib.c" : "API",
    "api_msg.c" : "API",
    "sockets.c" : "API",
    "def.c" : "HELPER",
    "err.c" : "HELPER",
    "inet_chksum.c" : "HELPER",
    "init.c" : "HELPER",
    "stats.c" : "HELPER",
    "etharp.c" : "ETH",
    "ethernet.c" : "ETH",
    "icmp.c" : "ICMP",
    "igmp.c" : "IGMP",
    "dhcp.c" : "DHCP",
    "dns.c" : "DNS",
    "ip4_addr.c" : "IPv4",
    "ip4_frag.c" : "IPv4",
    "ip4.c" : "IPv4",
    "mem.c" : "MEMORY",
    "memp.c" : "MEMORY",
    "netbuf.c" : "MEMORY",
    "netif.c" : "DRIVER",
    "pbuf.c" : "MEMORY",
    "sys_arch.c" : "OS_PORT",
    "tcp_in.c" : "TCP",
    "tcp_out.c" : "TCP",
    "tcp.c" : "TCP",
    "tcpip.c" : "TCP",
    "timeouts.c" : "TIMER",
    "udp.c" : "UDP",
    "xadapter.c" : "DRIVER",
    "xemacps_bdring.c" : "DRIVER",
    "xemacps_control.c" : "DRIVER",
    "xemacps_intr.c" : "DRIVER",
    "xemacps.c" : "DRIVER",
    "xemacpsif_dma.c" : "DRIVER",
    "xemacpsif_hw.c" : "DRIVER",
    "xemacpsif_physpeed.c" : "DRIVER",
    "xemacpsif.c" : "DRIVER",
    "xpqueue.c" : "DRIVER",
    
#    "ida_lwip_init.c" : "HELPER",
#    "ida_lwip_filter.c" : "FILTER",
#    "ida_lwip_igmp.c" : "IGMP",
#    "ida_lwip_monitor.c" : "PRIO_Q",
#    "ida_lwip_prio_queue.c" : "PRIO_Q",
#    "ida_lwip_sockets.c" : "API",
#	"ida_lwip_queue.c" : "FILTER",
#	"ida_lwip_virtEth.c" : "FILER", 
#	"ida_lwip_virtEth_master.c" : "FILTER"
	
	"ida_lwip_init.c" : "IDALWIP",
    "ida_lwip_filter.c" : "IDALWIP",
    "ida_lwip_igmp.c" : "IDALWIP",
    "ida_lwip_monitor.c" : "IDALWIP",
    "ida_lwip_prio_queue.c" : "IDALWIP",
    "ida_lwip_sockets.c" : "IDALWIP",
	"ida_lwip_queue.c" : "IDALWIP",
	"ida_lwip_virtEth.c" : "IDALWIP", 
	"ida_lwip_virtEth_master.c" : "IDALWIP"
}
    



result = subprocess.Popen(["nm", "--print-size" ,"--size-sort", "--radix=d", "-l" ,OBJ_FILE], stdout=subprocess.PIPE)
while True:
  line = result.stdout.readline().rstrip().lstrip().decode('utf8')
  if not line:
    break
  #the real code does filtering here
  parts = re.split(r'[\t\s]\s*', line)
  if len(parts) == 5:
      if parts[2] == 'T' or parts[2] == 't':
          filename = parts[4].split(":")[0]
          if filename.endswith(".c") and "/src/Modules/lwip" in filename:
            shortfilename = filename[filename.find("/src/Modules/lwip"):].rsplit('/',1)[-1]
            print("%s:%s:%d" %(shortfilename, parts[3], int(parts[1])))
            if shortfilename in functions:
                functions[shortfilename] += int(parts[1])
            else:
                functions[shortfilename] = int(parts[1])
    
for element in functions:
    if element in mapping:
        if mapping[element] in functionGroups:
            functionGroups[mapping[element]] += functions[element]
        else:
            functionGroups[mapping[element]] = functions[element]
    else:
        print("No mapping for %s" % element)

for group in functionGroups:
    print("%s %d" % (group ,functionGroups[group]))
    
            

    
