/*
 * app.c
 *
 *  Created on: Aug 12, 2020
 *      Author: kaige
 */

#include <stdio.h>
#include "cpu_core.h"
#include "ucos_ii.h"
#include "ucos_bsp.h"

#include "netif/xemacpsif.h"
#include "netif/xadapter.h"
#include "lwip/init.h"
#include "lwip/inet.h"
#include "lwip/opt.h"
#include "lwip/ip_addr.h"


#include "lwipopts.h"
#include <ucos_int.h>
#include "lwip/sockets.h"

#include "xipipsu.h"
#include "xscugic.h"

#include "netif/xemacps_ieee1588.h"
#include "ida-lwip/ida_lwip_init.h"
#include "ida-lwip/ida_lwip_filter.h"

#define UDP_SERVER_TASK_STACK_SIZE 1024
#define UDP_SERVER_TASK_PRIO 12

#define DUMMY_TASK_STACK_SIZE 512
#define DUMMY_TASK_PRIO 10

#define SOCK_CLIENT_TASK_STACK_SIZE 256
#define SOCK_CLIENT_TASK_PRIO 15


static CPU_STK socketClientTaskStk[SOCK_CLIENT_TASK_STACK_SIZE];



static void stopTest(void){
	while(1);;
}

char tx_buffer[1500];
void socketClientTask(void *p_arg){
	int socket_fd;
	struct sockaddr_in tx_sockAddr;
	int sent_data;

	OSTimeDly(OS_TICKS_PER_SEC * 5);

	printf("SOCKET RX SERVER TASK RUNNING\n");
	socket_fd = socket(PF_INET, SOCK_DGRAM, 0);
	if ( socket_fd < 0 )
	{
	    printf("ida server socket 1 create failed\n");
	    OSTaskDel(OS_PRIO_SELF);
	}

	memset(&tx_sockAddr, 0, sizeof(struct sockaddr_in));

	tx_sockAddr.sin_family = AF_INET;
	tx_sockAddr.sin_addr.s_addr = htonl(INADDR_ANY);//inet_addr("192.168.178.10");
	tx_sockAddr.sin_port = htons(1000);

	if (bind(socket_fd, (struct sockaddr *)&tx_sockAddr, sizeof(struct sockaddr_in)) == -1)
	{
		printf("ida server Bind to Port failed\n");
		close(socket_fd);
		OSTaskDel(OS_PRIO_SELF);
	}
	tx_sockAddr.sin_addr.s_addr = inet_addr("192.168.178.10");

	int i = 0;
	while(1){
		OSTimeDly(1);
		tx_sockAddr.sin_port = htons(1000+(i%10));
		tx_buffer[0] = (i%10);
		sent_data = sendto(socket_fd, tx_buffer,1030,0,(struct sockaddr*)&tx_sockAddr,sizeof(tx_sockAddr));
		if(i > 60000)
			stopTest();
		i++;
	}
}

void startAPP(void){

	OSTaskCreateExt(socketClientTask,
						NULL,
						&socketClientTaskStk[SOCK_CLIENT_TASK_STACK_SIZE - 1],
						SOCK_CLIENT_TASK_PRIO,
						SOCK_CLIENT_TASK_PRIO,
						&socketClientTaskStk[0],
						SOCK_CLIENT_TASK_STACK_SIZE,
						DEF_NULL,
						(OS_TASK_OPT_STK_CLR | OS_TASK_OPT_STK_CHK));
	OSTaskNameSet(SOCK_CLIENT_TASK_PRIO, (INT8U *) "sockClientTask", NULL);

	return;
}
