/*
 * ilm_table.c
 *
 *  Created on: 25.03.2019
 *      Author: kaige
 */


#include "ILM/if/ilm_core.h"
#include "stdio.h"
#include "imw_reader.h"
#include "imw_example_configs.h"

#define PAYLOAD(V,X,Y,Z)					{(X), (Y), (Z)}


extern IMW_READER_INTERNAL_t imwReader2Internal;

const ILM_HW_LET_TABLE_T C0_HW_Master_Table[] =
{
		{0,   (ILM_COREMASK_C0)},
		{10,   (ILM_COREMASK_C0)},
		{20,   (ILM_COREMASK_C0)},
		{30,   (ILM_COREMASK_C0)},
		{40,   (ILM_COREMASK_C0)},
		{50,  (ILM_COREMASK_C0)},
		{60,   (ILM_COREMASK_C0)},
		{70,   (ILM_COREMASK_C0)},
		{80,   (ILM_COREMASK_C0)},
		{90,   (ILM_COREMASK_C0)},
};



/*
* Configuration table for ILM Handler
*/


/**< \brief LET event table for C0 */
//This is the transmitting system !!!
const ILM_LET_TABLE_T CO_LET_TABLE[] =
{
		{0,   0,  ILM_EVENT_INCR, {((void*)&imwReader2Internal.currentObjectSeqNr),0,0}},
		{0,   9,  ILM_EVENT_TACT, {((void*)0), 0, 0}},
		{0,   IMW_LET_TASK_1_ID,  ILM_EVENT_TACT, {((void*)0), 0, 0}},
		{0,   IMW_LET_TASK_2_ID,  ILM_EVENT_TACT, {((void*)0), 0, 0}},
		{10,   9,  ILM_EVENT_TACT, {((void*)0), 0, 0}},
		{20,   9,  ILM_EVENT_TACT, {((void*)0), 0, 0}},
		{30,   9,  ILM_EVENT_TACT, {((void*)0), 0, 0}},
		{40,   9,  ILM_EVENT_TACT, {((void*)0), 0, 0}},
		{50,   0,  ILM_EVENT_INCR, {((void*)&imwReader2Internal.currentObjectSeqNr),0,0}},
		{50,   9,  ILM_EVENT_TACT, {((void*)0), 0, 0}},
		{50,   IMW_LET_TASK_2_ID,  ILM_EVENT_TACT, {((void*)0), 0, 0}},
		{60,   9,  ILM_EVENT_TACT, {((void*)0), 0, 0}},
		{70,   9,  ILM_EVENT_TACT, {((void*)0), 0, 0}},
		{80,   9,  ILM_EVENT_TACT, {((void*)0), 0, 0}},
		{90,   9,  ILM_EVENT_TACT, {((void*)0), 0, 0}},
};




const size_t CO_LET_TABLE_SIZE = sizeof(CO_LET_TABLE) / sizeof(ILM_LET_TABLE_T);			/**< \brief Number of LET event entries on C0 */
const size_t C0_HW_TABLE_SIZE = sizeof(C0_HW_Master_Table) / sizeof(ILM_HW_LET_TABLE_T);	/**< \brief Number of LET IRQ entries         */
