/*
 * imw_header.h
 *
 *  Created on: May 20, 2020
 *      Author: kaige
 */

#ifndef _IMW_HEADER_H_
#define _IMW_HEADER_H_

#include "stdint.h"

/**
 * \brief Possible submessage types
 */
typedef enum{
	IMW_SUBMESSAGE_SYNC = 0,	/**< \brief Sync Packet to synchronize obj. seq. nr */
	IMW_SUBMESSAGE_DATA = 1,	/**< \brief Data packet 							*/
	IMW_SUBMESSAGE_BITMAP = 2,	/**< \brief Bitmap packet							*/
}IMW_SUBMESSAGE_TYPE;

typedef struct __attribute__((packed)){
	uint16_t	seqNr;
	uint16_t	submessageType;
}IMW_HEADER_t;

typedef struct __attribute__((packed)){
	uint16_t 	objectId;
	uint16_t	objectSequenceNr;
	uint16_t	fragmentId;
	uint16_t	fragmentLength;
	uint16_t	padding;
}IMW_SUBMESSAGE_DATA_HEADER_t;

typedef struct __attribute__((packed)){
	uint16_t	objectId;
	uint16_t	objectSequenceNr;
}IMW_SUBMESSAGE_SYNC_HEADER_t;

typedef struct __attribute__((packed)){
	uint16_t	objectId;
	uint16_t	objectSequenceNr;
	uint16_t	bitmapSize;
}IMW_SUBMESSAGE_BITMAP_HEADER_t;

#endif /* _IMW_HEADER_H_ */
